'' Pixel Serial Client by Jeff Ledger
'' Proof of concept V1.0
'' 
'' Receive serial data on pin RX at 115200.
'' BYTE_X,BYTE_Y,BYTE_COLOR
''
'' Plot on 160x192 High Color 1 byte / Pixel Display
'' Thanks to Doug Dingus for the Video Driver

CON
  ' Set up the processor clock in the standard way for 80MHz on DemoBoard
  _CLKMODE = xtal1 + pll16x
  _XINFREQ = 5_000_000 + 0000

 RX = 1 'Pin Recieving Data

VAR
  byte          displayb[30720]   'allocate display buffer in RAM
                                  
  long          index             'temp offset for byte statement below

  long          i, j, k, l, m     'misc working vars

OBJ
  tv     : "160x96_hi-color_NTSC_demo_TV"  'the TV driver
  serial : "FullDuplexSerial"              'Standard serial driver
  
PUB start |  c, o, d, p, x,y,color,ss

    serial.start(RX, -1, 0, 115200)
   
    repeat index from 0 to 30720 
      byte [@displayb] [index] := @@clut[2]  'There is a CLUT in this program though
        
    tv.start(@displayb)  'start the tv cog & pass it the address of the bitmap

    repeat
       x:=serial.rx
       y:=serial.rx
       color:=serial.rx
       plot(x,y,color)
       x:=0
       y:=0
       color:=0

             
pub plot(x,y,c)
  'very simple dot plotter
  'one byte per pixel is sweet!

  'c := c & %0111 'uncomment for monochrome display only

    
  displayb[y*320+x] := @@clut[c & %01111111]   '128 color CLUT

DAT

clut
clut0   byte  byte  $02, $03, $04, $05, $06, $07, $07, $07
clut1   byte  byte  $19, $1a, $1b, $1c, $1d, $1e, $98, $af
clut2   byte  byte  $29, $2a, $2b, $2c, $2d, $2e, $a8, $bf
clut3   byte  byte  $39, $3a, $3b, $3c, $3d, $3e, $b8, $cf
clut4   byte  byte  $49, $4a, $4b, $4c, $4d, $4e, $c8, $df
clut5   byte  byte  $59, $5a, $5b, $5c, $5d, $5e, $d8, $ef
clut6   byte  byte  $69, $6a, $6b, $6c, $6d, $6e, $e8, $ff
clut7   byte  byte  $79, $7a, $7b, $7c, $7d, $7e, $f8, $0f
clut8   byte  byte  $89, $8a, $8b, $8c, $8d, $8e, $08, $1f
clut9   byte  byte  $99, $9a, $9b, $9c, $9d, $9e, $18, $2f
cluta   byte  byte  $a9, $aa, $ab, $ac, $ad, $ae, $28, $3f
clutb   byte  byte  $b9, $ba, $bb, $bc, $bd, $be, $38, $4f
clutc   byte  byte  $c9, $ca, $cb, $cc, $cd, $ce, $48, $5f
clutd   byte  byte  $d9, $da, $db, $dc, $dd, $de, $58, $6f
clute   byte  byte  $e9, $ea, $eb, $ec, $ed, $ee, $68, $7f
clutf   byte  byte  $f9, $fa, $fb, $fc, $fd, $fe, $78, $8f